uses crt;

const Souhvezdi_prevod: array[1..88,1..2] of string=(
('AND','And'), ('ANT','Ant'), ('APS','Aps'), ('AQR','Aqr'), ('AQL','Aql'),
('ARA','Ara'), ('ARI','Ari'), ('AUR','Aur'), ('BOO','Boo'), ('CAE','Cae'),
('CAM','Cam'), ('CNC','Cnc'), ('CVN','CVn'), ('CMA','CMa'), ('CMI','CMi'),
('CAP','Cap'), ('CAR','Car'), ('CAS','Cas'), ('CEN','Cen'), ('CEP','Cep'),
('CET','Cet'), ('CHA','Cha'), ('CIR','Cir'), ('COL','Col'), ('COM','Com'),
('CRA','CrA'), ('CRB','CrB'), ('CRV','Crv'), ('CRT','Crt'), ('CRU','Cru'),
('CYG','Cyg'), ('DEL','Del'), ('DOR','Dor'), ('DRA','Dra'), ('EQU','Equ'),
('ERI','Eri'), ('FOR','For'), ('GEM','Gem'), ('GRU','Gru'), ('HER','Her'),
('HOR','Hor'), ('HYA','Hya'), ('HYI','Hyi'), ('IND','Ind'), ('LAC','Lac'),
('LEO','Leo'), ('LMI','LMi'), ('LEP','Lep'), ('LIB','Lib'), ('LUP','Lup'),
('LYN','Lyn'), ('LYR','Lyr'), ('MEN','Men'), ('MIC','Mic'), ('MON','Mon'),
('MUS','Mus'), ('NOR','Nor'), ('OCT','Oct'), ('OPH','Oph'), ('ORI','Ori'),
('PAV','Pav'), ('PEG','Peg'), ('PER','Per'), ('PHE','Phe'), ('PIC','Pic'),
('PSC','Psc'), ('PSA','PsA'), ('PUP','Pup'), ('PYX','Pyx'), ('RET','Ret'),
('SGE','Sge'), ('SGR','Sgr'), ('SCO','Sco'), ('SCL','Scl'), ('SCT','Sct'),
('SER','Ser'), ('SEX','Sex'), ('TAU','Tau'), ('TEL','Tel'), ('TRI','Tri'),
('TRA','TrA'), ('TUC','Tuc'), ('UMA','UMa'), ('UMI','UMi'), ('VEL','Vel'),
('VIR','Vir'), ('VOL','Vol'), ('VUL','Vul')
);


var aavso,meduza: text;

{--------------------------------------------------}

procedure InitAll(aavso_t,meduza_t:string);
begin
  clrscr;

  Assign(aavso, aavso_t); { open file }
  Reset(aavso);

  Assign(meduza, meduza_t); { open file }
  Rewrite(meduza);
  Reset(meduza);
  Rewrite(meduza);

end;

{--------------------------------------------------}

procedure CloseAll;
begin
{
  clrscr;
}
  Close(aavso);   { Close file }
  Close(meduza);  { Close file }
end;

{--------------------------------------------------}

procedure rozdel(odkud,kam:integer;zdroj:string; var cil:string);
var  KdeJsem:integer;
begin
  cil:='';
  for KdeJsem:=odkud to kam do
  begin
    cil:=cil + zdroj[KdeJsem];
  end;
end;

{--------------------------------------------------}

procedure jd_obcanske(jd:real;var Year,Month:real; var Day:real);
var A,B,C,E,X,Z,Alpha:real;
    F:real;

begin
  Z:=int(jd + 0.5);
  F:=frac(jd + 0.5);

  if Z < 2299163 then
    begin
      A:=Z;
    end
  else
    begin
      Alpha:=int( (Z - 1867216.25)/36524.25);
      A:= Z + 1 + Alpha - int(Alpha/4);
    end;

  B := A + 1524;
  C := int( (B - 122.1)/365.25 );
  X := int( 365.25*C );
  E := int( ( B - X )/30.6001 );

  Day := B  - X - int(30.6001*E) + F;
  if E <= 13 then
    begin
      Month := E - 1;
    end
  else
    begin
      Month := E - 13;
    end;

  if Month <= 2 then
    begin
      Year := C - 4715;
    end
  else
    begin
      Year := C - 4716;
    end;

end;


{--------------------------------------------------}

function IsAlpha(var Co:char):boolean;
begin
  if ((co>='a')and(co<='z'))or((co>='A')and(co<='Z')) then 
  begin
    IsAlpha:=true;
  end
  else
  begin
    IsAlpha:=false;
  end;
end;

{--------------------------------------------------}

function IsDigit(var Co:char):boolean;
begin
  if (co>='0')and(co<='9')   then
  begin
    IsDigit:=true;
  end
  else
  begin
    IsDigit:=false;
  end;
end;

{--------------------------------------------------}

procedure OdhadSMezerami(Zdroj:string;var Odhad:string);
var i:integer;
    stred:integer;
    Pom,Pstr:string;
    nasel:boolean;
begin
  nasel:=false;
  stred:=0;
  i:=3;
  if Length(Zdroj)>i then
  begin
    repeat
      if (Zdroj[i-1]=' ')and((Zdroj[i]='V')or(Zdroj[i]='v'))and(Zdroj[i+1]=' ') then 
      begin 
        stred:=i;
		nasel:=true;
	  end;	
      inc(i);
    until (stred>0)or(Length(Zdroj)=i);
  
    if Length(Zdroj)=i then
    begin
    {
      V komentari se nevyskytuji sekvence ' V ' potrebna k detekci odhadu
    }
      Pstr:='V';
    end
    else
    begin
      Pstr:='';
      Pom:='';

      i:=2;
      while Zdroj[stred-i]<>' ' do
      begin
        Pom:=Pom+Zdroj[stred-i];
        inc(i);
      end;

      {
       srovnavacka:
      }
      inc(i);
      if IsDigit(Zdroj[stred-i]) then 
	  begin
  	    Pom:=Pom+'-';
        while (IsDigit(Zdroj[stred-i]))and(stred-i>=0) do
        begin
          Pom:=Pom+Zdroj[stred-i];
          inc(i);
        end;
	  end
	  else
	  begin
        while (IsAlpha(Zdroj[stred-i]))and(stred-i>=0) do
        begin
          Pom:=Pom+Zdroj[stred-i];
          inc(i);
        end;
	  end;

      for i:=1 to Length(Pom) do Pstr:=Pstr+Pom[Length(Pom)-i+1];

      {
	    'V' ci 'v'
	  }
      Pstr:=Pstr+Zdroj[stred];
      {
       odhad:
      }
      i:=2;
      while Zdroj[stred+i]<>' ' do
      begin
        Pstr:=Pstr+Zdroj[stred+i];
        inc(i);
      end;

      inc(i);

{srovnavacka}
      if IsDigit(Zdroj[stred+i]) then 
      begin
        Pstr:=Pstr+'-';
	    while IsDigit(Zdroj[stred+i])and(stred+i<=Length(Zdroj)) do
		begin
          Pstr:=Pstr+Zdroj[stred+i];
		  inc(i);
		end;
      end
      else
	  begin
	    while IsAlpha(Zdroj[stred+i])and(stred+i<=Length(Zdroj)) do
		begin
          Pstr:=Pstr+Zdroj[stred+i];
		  inc(i);
		end;
	  end;

    end;
  end
  else
  begin
  {
    komentatr je kratsi, nebo roven trem znakum...
  }
    Pstr:='V';
  end;

  Odhad:=Pstr;

end;

{--------------------------------------------------}

procedure OdhadBezMezer(Zdroj:string;var odhad:string);
var i:integer;
    stred:integer;
    Pom,Pstr:string;
	nasel:boolean;
begin
  odhad:='V';
  Pom:='';
  nasel:=false;
  stred:=0;
  i:=3;
  if Length(Zdroj)>i then
  begin
  {Hledam stred odhadu - 'cisloVcislo'}
    repeat
    if (IsDigit(Zdroj[i-1])=true)and((Zdroj[i]='V')or(Zdroj[i]='v'))and(IsDigit(Zdroj[i+1])=true) then 
	begin
	  stred:=i;
	  nasel:=true;
	end;  
      inc(i);
    until (stred>0)or(Length(Zdroj)=i);

    if nasel then 
	begin

      if Zdroj[stred-2]='-' then
	  begin{vlevo je cislo}
        i:=3;
        while (IsDigit(Zdroj[stred-i]))and(stred-i>=0) do
        begin
		  Pom:=Pom+Zdroj[stred-i];
		  inc(i);
		end;
		odhad:='';
		for i:=Length(Pom) downto 1 do odhad:=odhad+Pom[i];
		odhad:=odhad+'-';
	  end
	  else
	  begin{vlevo je pismenko/pismena}
        odhad:='';
        Pom:='';
        i:=2;
        while (IsAlpha(Zdroj[stred-i]))and(stred-i>=0) do
        begin
		  Pom:=Pom+Zdroj[stred-i];
		  inc(i);
		end;
		for i:=Length(Pom) downto 1 do odhad:=odhad+Pom[i];
	  end;{zdroj[stred-2]='-'}
	  
  	  odhad:=odhad + Zdroj[stred-1]+Zdroj[stred]+Zdroj[stred+1];

      if Zdroj[stred+2]='-' then
      begin{vpravo je cislo}
        i:=3;
        odhad:=odhad+'-'; 
        while IsDigit(Zdroj[stred+i])and(stred+i<=Length(Zdroj)) do
        begin
          odhad:=odhad+Zdroj[stred+i];
          inc(i);
        end;
      end
      else
      begin{vpravo je pismenko/pismena}
        i:=2;
        while IsAlpha(Zdroj[stred+i])and(stred+i<=Length(Zdroj)) do
        begin
          odhad:=odhad+Zdroj[stred+i];
          inc(i);
        end;
{        odhad:=odhad + Zdroj[stred+2];}
      end;{zdroj[stred+2]='-'}
	  
	end{nasel jsem odhad.}
	else
	begin
	  odhad:='V';
	end;

  end;
end;

{--------------------------------------------------}

procedure NajdiOdhad(var Zdroj:string);
var odhad:string;
    nasel:boolean;
begin
  nasel:=false;

  OdhadSMezerami(Zdroj,odhad);
  if (odhad<>'V')and(odhad<>'v') then 
  begin 
    Zdroj:=odhad;
	nasel:=true;
  end;	 

  if nasel=false then 
  begin
    OdhadBezMezer(Zdroj,Odhad);
	if (odhad<>'V')and(odhad<>'v') then
	begin
	  Zdroj:=Odhad;
	  nasel:=true;
	end;
  end;	

 if nasel=false then Zdroj:='V';
end;

{--------------------------------------------------}

procedure ZpracujRadek(data:string);
var PomocnyString,Datum:string;
    KdeJsem:integer;
    Rok,Mesic,Den:real;
    jd:real;
    Code:integer;
    mezera,i:integer;
    hvezd,souhv:string;
begin
 KdeJsem:=1;
 PomocnyString:='';
{
  Nazev promenky
}
{
  rozdel(9,18,data,PomocnyString);
  Write(meduza,PomocnyString);
}

  rozdel(9,18,data,PomocnyString);
  Hvezd:='';
  Souhv:='';

  i:=1;
  while (PomocnyString[i]<>' ')and(i<=Length(PomocnyString)) do
  begin
    Hvezd:=Hvezd + PomocnyString[i];
    inc(i);
  end;

  inc(i);

  while (PomocnyString[i]<>' ')and(i<=Length(PomocnyString)) do
  begin
    Souhv:=Souhv + PomocnyString[i];
    inc(i);
  end;

  for i:=1 to 88 do
  begin
    if Souhv=Souhvezdi_prevod[i,1] then Souhv:=Souhvezdi_prevod[i,2];
  end;

  PomocnyString:=Hvezd + ' ' + Souhv;
  Write(meduza,PomocnyString);

  mezera:=10 - Length(PomocnyString);
  for i:=1 to mezera do
  begin
    Write(meduza,' ');
  end;


{
  Julianske datum
}
  rozdel(19,26,data,PomocnyString);
  Write(meduza,PomocnyString);

  rozdel(26,30,data,PomocnyString);
  Val(PomocnyString, jd, Code);
  jd:=round(jd*1000);
  Str(jd:3:0,PomocnyString);
  Write(meduza,PomocnyString);

  rozdel(19,30,data,PomocnyString);
  Val(PomocnyString, jd, Code);

{
 aby to bylo na spravnem miste...
}
  Write(meduza,'  ');
{
  magnituda
}
  rozdel(31,31,data,PomocnyString);
  if PomocnyString = '<' then
    begin
      PomocnyString:=' <';
      Write(meduza,PomocnyString);
      rozdel(32,35,data,PomocnyString);
      Write(meduza,PomocnyString);
    end
  else
    begin
      Write(meduza,PomocnyString);
      rozdel(32,35,data,PomocnyString);
      Write(meduza,PomocnyString);
      Write(meduza,' ');
    end;

{
  korekce
}
  Write(meduza,' ');
{
  Datum  - obcanske
}
  jd_obcanske(jd,Rok,Mesic,Den);

  Write(Meduza,'    ');

  Str(Rok:4:0,datum);
  Str(Mesic:2:0,PomocnyString);
  if PomocnyString[1] = ' ' then
  begin
    Str(Mesic:1:0,PomocnyString);
    PomocnyString:='0' + PomocnyString;
  end;
  Datum:=Datum + '-' + PomocnyString;

  Den:=round(Den*1000)/1000;
  Str(Den:5:3,PomocnyString);
  if Den < 10 then
     PomocnyString:='0' + PomocnyString;

  Datum:=Datum + '-' + PomocnyString;

  Write(Meduza,Datum);

{
  korekce
}
  mezera:=14 - Length(Datum);
  for i:=1 to mezera do
  begin
    Write(meduza,' ');
  end;
  Write(meduza,'      ');
{
  zkratka pozorovatele
}

  rozdel(63,66,data,PomocnyString);
  Write(meduza,PomocnyString);

{
  korekce
}
  Write(meduza,'      ');
{
  O odhad, znak nejisteho chovani a ukonceni radku se stara
  procedura Convert.
}
end;

{--------------------------------------------------}

procedure RadekJePromenka(radek:string;var test:boolean);
begin
  if (length(radek)>5)and((radek[5]='+')or(radek[5]='-'))and( (radek[4]>='0')and(radek[4]<='9') ) then
  begin
    test:=true;
  end
  else
  begin
    test:=false;
  end;
end;	


procedure Convert;
var radek_ted,radek_priste:string;
    PomocnyString:string;
	ted,priste:boolean; {true=>promenka, false=>odhady,komentare atp.}
begin
  Readln(aavso, radek_priste);
  while not Eof(aavso) do
  begin
    radek_ted:=radek_priste;
    Readln(aavso, radek_priste);
	
    RadekJePromenka(radek_ted,ted);
    RadekJePromenka(radek_priste,priste);
	
	if (ted=true)and(priste=true) then
	begin
  	  ZpracujRadek(radek_ted);

	  if Length(radek_ted)>77 then
	  begin
	    rozdel(78,Length(radek_ted),radek_ted,PomocnyString);
	    NajdiOdhad(PomocnyString);
	    Write(meduza,PomocnyString);
 	  end
	  else
	  begin
	    Write(meduza,'V');
	  end;

      rozdel(36,36,radek_ted,PomocnyString);
      Write(meduza,PomocnyString);
	  writeln(meduza,'');
	end;


    if (ted=true)and(priste=false) then
	begin
  	  ZpracujRadek(radek_ted);
      rozdel(36,36,radek_ted,PomocnyString);

	  NajdiOdhad(radek_priste);
	  write(meduza,radek_priste);

	  Writeln(meduza,PomocnyString);
	end;

  end;
end;


{--------------------------------------------------}
{--------------------------------------------------}
{--------------------------------------------------}


begin

  if ParamCount <> 2 then
    begin
      Writeln('Program aa2med ver. 1.3');
      Writeln('Konvertor dat z formatu aavso do formatu medusa');
      Writeln('Pred odeslanim dat do Medusy nezapomente doplnit');
      Writeln('tvar odhadu. Zacinaji na pozici 65 - je tam V');
      Writeln('Odhad je mozne zadat do *.sum souboru ve forme:');
      Writeln('a2V3b, 123-3V2-135, a2V-123, ci a 3 V 4 145');
      Writeln('vysledkem je vzdy odhad ve forme pro Meduzu');  
      Writeln('');
      Writeln('Pouziti:');
      Writeln('');
      Writeln('aa2med vstup vystup');
      Writeln('');
      Writeln('Na vstupu se predpoklada soubor formatu *.sum');
      Writeln('neboli soubor vytvoreny programem ksolo 4.2');
      Writeln('Vystup lze po doplneni tvaru odhadu odeslat do Medusy.');
      Writeln('');
      Writeln('Pripadne problemy hlaste na adresu:');
      Writeln('jazyk@artax.karlin.mff.cuni.cz');
    end
  else
    begin
      InitAll(ParamStr(1),ParamStr(2));
      Convert;
      CloseAll;
    end;

end.
